#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


# define  NMAXCARATT 30
# define  NMAXDOCU 20
# define  LPAROLE 100


int caricaKeyword(char [NMAXCARATT][LPAROLE]);
void caricaDocumenti(double [NMAXDOCU][NMAXCARATT]);
void stampaKeyword(char [NMAXCARATT][LPAROLE], int );
void stampaDocumenti(double [NMAXDOCU][NMAXCARATT]);
int caricaQuery(char [NMAXCARATT][LPAROLE]);
void costruisciQuery(char [NMAXCARATT][LPAROLE], int , char [NMAXCARATT][LPAROLE], double [NMAXCARATT]);
double calcolaModulo(double [NMAXCARATT], int );
double calcolaCoseno(double [NMAXCARATT], double [NMAXCARATT], int );
int trovaDocumento (double [NMAXCARATT], double [NMAXDOCU][NMAXCARATT], double *);

int main ()
{

  char query[NMAXCARATT][LPAROLE];
  char ElencoParole[NMAXCARATT][LPAROLE];
  int i,itmp,scelta,n_parole_cercate,controllo=0,n_keyword;
  double coseno;
  double ElencoCaratteristiche[NMAXDOCU][NMAXCARATT];
  double QueryReale[NMAXCARATT];

  n_keyword=caricaKeyword(ElencoParole);
  if(n_keyword!=NMAXCARATT){
    printf("Il numero di keyword  insufficiente\n");
	exit(0);
  }

  caricaDocumenti(ElencoCaratteristiche);


  scelta=0;
  while(scelta!=6){
    system("cls\n");
    printf("MENU:\n\n");
    printf("1) Stampa a video l\'elenco delle keyword\n");
    printf("2) Stampa a video le caratteristiche dei documenti\n");
    printf("3) Stampa a video il vettore QueryReale\n");
    printf("4) Distanza dal documeno dato\n");
    printf("5) Documeno piu' vicino\n");
    printf("6) Esci\n");

    scanf("%d",&scelta);

    switch(scelta){
      case 1:
		     stampaKeyword(ElencoParole,n_keyword);
			 getchar();getchar();
 		     break;
      case 2:
		     stampaDocumenti(ElencoCaratteristiche);
			 getchar();getchar();
		     break;
      case 3:
		     //l'utente crea la query
			 n_parole_cercate=caricaQuery(query);

		     //il programma spalma la query sulla lunghezza effettiva del vettore totale
			 costruisciQuery(query,n_parole_cercate,ElencoParole,QueryReale);

			 //stampa a video della query spalmata
			 printf("Vettore QueryReale: \n");
			 for(i=0;i<NMAXCARATT;i++)
				 printf("caratt. n.%d:  %lf\n",i,QueryReale[i]);
			 controllo=1;
			 getchar();getchar();
		     break;
      case 4:
		     if(controllo==0){
			   printf("Prima devi estrarre le caratteristiche...\n");
		 	   getchar();getchar();
		       break;
			 }
             do{
			   printf("Inserisci il numero di ordine del documento che vuoi vedere:  ");
			   scanf("%d",&itmp);
			 }while((itmp<0)||itmp>NMAXDOCU-1);

		     coseno=calcolaCoseno(QueryReale,ElencoCaratteristiche[itmp],NMAXCARATT);
			 printf("La distanza e': %lf\n",coseno);

			 getchar();getchar();
		     break;
      case 5:
		     if(controllo==0){
			   printf("Prima devi estrarre le caratteristiche...\n");
		 	   getchar();getchar();
		       break;
			 }
		     itmp=trovaDocumento(QueryReale,ElencoCaratteristiche,&coseno);
			 printf("Il documento piu' vicino e'il numero: %d, con un coseno di %lf\n",itmp,coseno);
			 getchar();getchar();
		     break;
      case 6:
		     break;
      default:
		     break;

    }//switch
  }//while


  printf("Fine programma\n");

}


int trovaDocumento (double v1[NMAXCARATT], double matelenco[NMAXDOCU][NMAXCARATT], double *massimo)
{
  int i,posizione;
  double coseno;

  *massimo=-1.0;

  for(i=0;i<NMAXDOCU;i++){
    coseno=calcolaCoseno(v1,matelenco[i],NMAXCARATT);
	if(coseno>*massimo){
       *massimo=coseno;
	   posizione=i;
	}
  }

  return posizione;

}



double calcolaModulo(double v[NMAXCARATT], int n)
{

  int i;
  double somma=0;

  for(i=0;i<n;i++)
	  somma+=v[i]*v[i];

  return sqrt(somma);

}

double calcolaCoseno(double v1[NMAXCARATT], double v2[NMAXCARATT], int n)
{

  int i;
  double mod1,mod2,pr_scalare;

  mod1=calcolaModulo(v1,n);
  mod2=calcolaModulo(v2,n);

  if(mod1<0){
     printf("mod1<0:   %lf\n",mod1);
     exit(0);
  }

  if(mod2<0){
     printf("mod2<0:   %lf\n",mod2);
     exit(0);
  }


  pr_scalare=0;
  for(i=0;i<n;i++)
	 pr_scalare+=v1[i]*v2[i];


  if(mod1*mod2!=0)
	  return pr_scalare/(mod1*mod2);
  else
	  return -1;//almeno uno dei due vettori e' nullo

}


void costruisciQuery (char query[NMAXCARATT][LPAROLE], int n, char elenco[NMAXCARATT][LPAROLE], double QueryReale[NMAXCARATT])
{

  int i,j,n_parole_cercate;

  for(j=0;j<NMAXCARATT;j++)
    for(i=0;i<n;i++)
       if(strcmp(query[i],elenco[j])==0){
		 QueryReale[j]=1;
		 break;
	   }
	   else
		 QueryReale[j]=0;

}

void stampaKeyword(char mat[NMAXCARATT][LPAROLE], int n)
{

  int i;

  printf("Elenco caratteristiche ricercabili: \n");

  for(i=0;i<n;i++)
	printf("%s\n",mat[i]);

}



void stampaQuery(char query[NMAXCARATT][LPAROLE], int n)
{

  int i;

  printf("Query:\n");
  for(i=0;i<n;i++)
    printf("parola n. %d: %s\n",i,query[i]);

}


void stampaDocumenti(double matCar[NMAXDOCU][NMAXCARATT])
{

  int i,j;

  printf("Valori documenti: \n");

  for(i=0;i<NMAXDOCU;i++){
    for(j=0;j<NMAXCARATT;j++)
	  printf("%lf ",matCar[i][j]);
    printf("\n");
  }

}


int caricaKeyword(char mat[NMAXCARATT][LPAROLE])
{

  int i,j,itmp;
  FILE *fid;

  fid=fopen("elencoparole.txt","r");
  if(fid==NULL){
    printf("Non ho trovato il file elencoparole.txt\n");
    exit(0);
  }

  //leggo le parole chiave
  for(i=0;i<NMAXCARATT;i++){
	itmp=fscanf(fid,"%s",mat[i]);
	if(itmp==EOF)  //quando raggiungo la fine del file mi fermo
		break;
  }

  fclose(fid);

  return i; //questo  il numero di parole lette

}





void caricaDocumenti(double matCar[NMAXDOCU][NMAXCARATT])
{

  int i,j;
  FILE *fid;


  fid=fopen("elencocaratteristiche.txt","r");
  if(fid==NULL){
    printf("Non ho trovato il file elencocaratteristiche.txt\n");
    exit(0);
  }

  for(i=0;i<NMAXDOCU;i++)
    for(j=0;j<NMAXCARATT;j++)
	  fscanf(fid,"%lf",&(matCar[i][j]));

  fclose(fid);

}


int caricaQuery(char mat[NMAXCARATT][LPAROLE])
{

  int i,nCaratteristiche;

  printf("dammi il numero di parole della query:  ");
  scanf("%d",&nCaratteristiche);

  for(i=0;i<nCaratteristiche;i++){
    printf("Parola n. %d:  ",i);
	scanf("%s",mat[i]);
  }

  return nCaratteristiche;
}
